/*
 * GameMap.cpp
 *
 *  Created on: 31/mar/2014
 *      Author: bertini
 */

#include "GameMap.h"
#include <iostream>

GameMap::GameMap(int w, int h) : width(w), height(h) {
	map = new Tile[width * height];
}

GameMap::GameMap(const GameMap& gm) {
	copier(gm);
}

GameMap::~GameMap() {
	delete[] map;
}

void GameMap::setTile(int x, int y, const Tile& t) {
	if ((x < width) && (y < height))
		map[x + y * width] = t;
}

Tile GameMap::getTile(int x, int y) const {
	if ((x < width) && (y < height))
		return map[x + y * width];
	else
		return Tile(0, true); // we won't need this type of return when we'll see how exceptions work...
}

GameMap& GameMap::operator=(const GameMap& rh) {
	if (this != &rh) {  // make sure not same object
		delete[] map;   // Delete old map memory.
		copier(rh);
	}
	return *this;    // Return reference for multiple assignment
}

void GameMap::printMap() const {
	// TODO implement using std::cout
}

void GameMap::copier(const GameMap& gm) {
	width = gm.width;
	height = gm.height;
	map = new Tile[width * height];
	for (int x = 0; x < width; x++) {
		for (int y = 0; y < height; y++) {
			map[x + y * width] = gm.getTile(x, y);
		}
	}
}
