/*
 * game.cpp
 *
 *  Created on: 24/mar/2014
 *      Author: bertini
 */

#include <iostream>

#include "Character.h"
#include "Knight.h"
#include "Wizard.h"
#include "Monster.h"
#include "Sword.h"
#include "Fang.h"
#include "Tile.h"
#include "GameMap.h"

int main() {
	GameMap* map1 = new GameMap(2,2);
	// TODO create 4 tiles
	// TODO add tiles to map1
	// TODO create GameMap map2 cloning map1
	delete map1;
	// TODO print map2... is it possible ? What if there was no operator= or copy constructor with deep copy ?

	Weapon* sword = new Weapon(3);
	Character* hero = new Knight("Boromir", 36, 1, 6);
	hero->setWeapon(sword);

	Character* hero2 = new Wizard("Gandalf", 30, 2, 6);

	const int numPlayers = 2;
	Character* heroTeam[numPlayers];
	heroTeam[0] = hero;
	heroTeam[1] = hero2;

	Weapon* fang = new Fang(3, false);
	Character* orc = new Monster(30, 1, 1);
	orc->setWeapon(fang);
	orc->setName("orc");

	for (int i = 0; i < numPlayers; i++) {
		Wizard* wizardHero = dynamic_cast<Wizard*>(heroTeam[i]);
		if (wizardHero) {
			wizardHero->doMagic(*orc);
		} else {
			int damage = heroTeam[i]->fight(*orc);
			if (damage)
				std::cout << heroTeam[i]->getName() << " hits the orc - damage: " << damage
						<< " points" << std::endl;

			Weapon* magicSword = new Sword(7, true);
			// give the magicSword to the current character
			damage = heroTeam[i]->fight(*orc);
			if (damage)
				std::cout << heroTeam[i]->getName() << " hits the orc - damage: " << damage
						<< " points" << std::endl;
		}
	}


	delete hero;
	delete hero2;
	delete orc;
}
